<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Ray Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_ray.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_ray-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Ray Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate 3D rays.  
 <a href="class_ray.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_ray_8hpp_source.html">Ray.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a96038ba150ebc0ab85c515cfb097c6cd"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray.html#a96038ba150ebc0ab85c515cfb097c6cd">Ray</a> (<a class="el" href="class_vec.html">Vec</a> _o, <a class="el" href="class_vec.html">Vec</a> _d)</td></tr>
<tr class="memdesc:a96038ba150ebc0ab85c515cfb097c6cd"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> Constructor. A ray is defined as o + td, where o is the origin of the ray and d is the direction vector.  <a href="#a96038ba150ebc0ab85c515cfb097c6cd">More...</a><br /></td></tr>
<tr class="separator:a96038ba150ebc0ab85c515cfb097c6cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a921c1b4282b604067d1e22de870c362d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray.html#a921c1b4282b604067d1e22de870c362d">tip_point</a> (double t)</td></tr>
<tr class="memdesc:a921c1b4282b604067d1e22de870c362d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the point along the ray for a given t.  <a href="#a921c1b4282b604067d1e22de870c362d">More...</a><br /></td></tr>
<tr class="separator:a921c1b4282b604067d1e22de870c362d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a167f59267ea3d32cb3a69f50ec13aeda"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray.html#a167f59267ea3d32cb3a69f50ec13aeda">o</a></td></tr>
<tr class="memdesc:a167f59267ea3d32cb3a69f50ec13aeda"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>'s origin vector.  <a href="#a167f59267ea3d32cb3a69f50ec13aeda">More...</a><br /></td></tr>
<tr class="separator:a167f59267ea3d32cb3a69f50ec13aeda"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa717ed3c35d27340583ddcc616df8c1b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray.html#aa717ed3c35d27340583ddcc616df8c1b">d</a></td></tr>
<tr class="memdesc:aa717ed3c35d27340583ddcc616df8c1b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Rays's direction vector.  <a href="#aa717ed3c35d27340583ddcc616df8c1b">More...</a><br /></td></tr>
<tr class="separator:aa717ed3c35d27340583ddcc616df8c1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a28fc10d4a43d1a1e11111cee9f0ea2c0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray.html#a28fc10d4a43d1a1e11111cee9f0ea2c0">inv_d</a></td></tr>
<tr class="separator:a28fc10d4a43d1a1e11111cee9f0ea2c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate 3D rays. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a96038ba150ebc0ab85c515cfb097c6cd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a96038ba150ebc0ab85c515cfb097c6cd">&sect;&nbsp;</a></span>Ray()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Ray::Ray </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_d</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> Constructor. A ray is defined as o + td, where o is the origin of the ray and d is the direction vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_o</td><td><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>'s origin Vector </td></tr>
    <tr><td class="paramname">_d</td><td><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>'s direction Vector </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a921c1b4282b604067d1e22de870c362d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a921c1b4282b604067d1e22de870c362d">&sect;&nbsp;</a></span>tip_point()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Ray::tip_point </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the point along the ray for a given t. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">t</td><td>Parameter to scale the direction vector from the origin </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="aa717ed3c35d27340583ddcc616df8c1b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa717ed3c35d27340583ddcc616df8c1b">&sect;&nbsp;</a></span>d</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Ray::d</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Rays's direction vector. </p>

</div>
</div>
<a id="a28fc10d4a43d1a1e11111cee9f0ea2c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a28fc10d4a43d1a1e11111cee9f0ea2c0">&sect;&nbsp;</a></span>inv_d</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Ray::inv_d</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a167f59267ea3d32cb3a69f50ec13aeda"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a167f59267ea3d32cb3a69f50ec13aeda">&sect;&nbsp;</a></span>o</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Ray::o</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>'s origin vector. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="_ray_8hpp_source.html">Ray.hpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_ray.html">Ray</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
